// FontMapper.cpp : DLL  α׷   Լ մϴ.
//

#include "stdafx.h"
#include "NewAPIs.h"
#include "ATPlugin.h"
#include "Wrapper.h"

HMODULE g_hThisModule = NULL;
HWND	g_hAralWnd = NULL;
LPWSTR	g_wszPluginOption = NULL;
CONTAINER_PROC_ENTRY g_sATCTNR3 = {NULL, };
PROC_WideCharToMultiByte g_pfnOrigWideCharToMultiByte = NULL;
PROC_MultiByteToWideChar g_pfnOrigMultiByteToWideChar = NULL;

const int g_nbaseBufSize=4096;

BOOL APIENTRY DllMain( HMODULE hModule,
					  DWORD  ul_reason_for_call,
					  LPVOID lpReserved
					  )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		g_hThisModule = hModule;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}

extern "C" __declspec(dllexport) BOOL __stdcall GetPluginInfo(PLUGIN_INFO* pPluginInfo)
{
	BOOL bRetVal = FALSE;

	if(sizeof(PLUGIN_INFO) <= pPluginInfo->cch)
	{
		memcpy_s(pPluginInfo,sizeof(PLUGIN_INFO),&getPluginInfo(),sizeof(PLUGIN_INFO));
		bRetVal = TRUE;
	}

	return bRetVal;
}

extern "C" __declspec(dllexport) BOOL __stdcall OnPluginInit(HWND hAralWnd, LPWSTR wszPluginOption)
{
	BOOL bRetVal = FALSE;

	try
	{
		//////////////////////////////////////////////////////////////////////////
		// Initializing Code
		//////////////////////////////////////////////////////////////////////////
		
		g_hAralWnd = hAralWnd;
		if(NULL == g_hAralWnd || INVALID_HANDLE_VALUE == g_hAralWnd)
			throw _T("Invalid AralTrans Window Handle!");

		g_wszPluginOption = wszPluginOption;
		if(NULL == g_wszPluginOption)
			throw _T("Invalid Option String Pointer!");

		// Get AT container
		HMODULE hATCTNR3 = GetModuleHandle(_T("ATCTNR3.DLL"));
		if(NULL == hATCTNR3 || INVALID_HANDLE_VALUE == hATCTNR3)
			throw _T("Can not find ATCTNR3.DLL handle!");

		// Get AT container procedures
		ZeroMemory(&g_sATCTNR3, sizeof(CONTAINER_PROC_ENTRY));
		g_sATCTNR3.procHookWin32Api			= (PROC_HookWin32Api) GetProcAddress(hATCTNR3, "HookWin32Api");
		g_sATCTNR3.procUnhookWin32Api		= (PROC_UnhookWin32Api) GetProcAddress(hATCTNR3, "UnhookWin32Api");
		g_sATCTNR3.procHookCodePoint		= (PROC_HookCodePoint) GetProcAddress(hATCTNR3, "HookCodePoint");
		g_sATCTNR3.procUnhookCodePoint		= (PROC_UnhookCodePoint) GetProcAddress(hATCTNR3, "UnhookCodePoint");
		g_sATCTNR3.procCreateTransCtx		= (PROC_CreateTransCtx) GetProcAddress(hATCTNR3, "CreateTransCtx");
		g_sATCTNR3.procDeleteTransCtx		= (PROC_DeleteTransCtx) GetProcAddress(hATCTNR3, "DeleteTransCtx");
		g_sATCTNR3.procTranslateUsingCtx	= (PROC_TranslateUsingCtx) GetProcAddress(hATCTNR3, "TranslateUsingCtx");
		g_sATCTNR3.procIsAppLocaleLoaded	= (PROC_IsAppLocaleLoaded) GetProcAddress(hATCTNR3, "IsAppLocaleLoaded");
		g_sATCTNR3.procSuspendAllThread		= (PROC_SuspendAllThread) GetProcAddress(hATCTNR3, "SuspendAllThread");
		g_sATCTNR3.procResumeAllThread		= (PROC_ResumeAllThread) GetProcAddress(hATCTNR3, "ResumeAllThread");
		g_sATCTNR3.procIsAllThreadSuspended = (PROC_IsAllThreadSuspended) GetProcAddress(hATCTNR3, "IsAllThreadSuspended");

		if(!(g_sATCTNR3.procHookWin32Api && g_sATCTNR3.procUnhookWin32Api
			&& g_sATCTNR3.procHookCodePoint && g_sATCTNR3.procUnhookCodePoint
			&& g_sATCTNR3.procCreateTransCtx && g_sATCTNR3.procDeleteTransCtx
			&& g_sATCTNR3.procTranslateUsingCtx && g_sATCTNR3.procIsAppLocaleLoaded
			&& g_sATCTNR3.procSuspendAllThread && g_sATCTNR3.procResumeAllThread
			&& g_sATCTNR3.procIsAllThreadSuspended))
			throw _T("Failed to get container procedures!");

		// Prevent Applocale Redirection
		HKEY hCategoryKey = HKEY_CURRENT_USER;
		HKEY hKey = NULL;
		LONG lRet = RegOpenKeyEx(hCategoryKey, _T("Software\\AralGood"), 0, KEY_READ, &hKey);

		// Ű µ ߴٸ
		if(lRet == ERROR_SUCCESS)
		{
			DWORD type = REG_DWORD;
			DWORD size = MAX_PATH*2;
			BYTE dir[MAX_PATH*2];

			if(RegQueryValueEx(hKey, _T("M2WAddr"), 0, &type, (LPBYTE)&dir, &size) == ERROR_SUCCESS)
				memcpy( &g_pfnOrigMultiByteToWideChar, &dir, sizeof(DWORD) );

			if(RegQueryValueEx(hKey, _T("W2MAddr"), 0, &type, (LPBYTE)&dir, &size) == ERROR_SUCCESS)
				memcpy( &g_pfnOrigWideCharToMultiByte, &dir, sizeof(DWORD) );
		}


		// ɼ Ʈ Ľ
		g_wszPluginOption = wszPluginOption;

		//   簡
		g_sATCTNR3.procResumeAllThread();

		bRetVal = TRUE;

	}
	catch (LPCTSTR strErr)
	{
		::MessageBox(NULL, strErr, _T("ATPlugin"), MB_OK | MB_TOPMOST);
		OnPluginClose();
	}


	if( bRetVal == TRUE )
	{
		// ɼ 
	}

	return bRetVal;
}

extern "C" __declspec(dllexport) BOOL __stdcall OnPluginClose()
{
	if(NULL == g_hAralWnd) return FALSE;

	BOOL bRetVal = FALSE;

	// Suspend All Threads
	g_sATCTNR3.procSuspendAllThread();

	bRetVal=closePlugin();

	// Ÿ  
	g_hAralWnd = NULL;
	g_wszPluginOption = NULL;

	//   簡
	g_sATCTNR3.procResumeAllThread();

	return bRetVal;
}

extern "C" __declspec(dllexport) BOOL __stdcall OnPluginOption()
{
	BOOL bRetVal = FALSE;

	// Show option dialog and Interact with user.
	if (g_hAralWnd && IsWindow(g_hAralWnd))
	{
		bRetVal = showPluginOption(g_hAralWnd,g_wszPluginOption);
	}

	return bRetVal;
}

extern "C" __declspec(dllexport) BOOL __stdcall OnObjectInit(TRANSLATION_OBJECT* pTransObj)
{
	if(NULL == pTransObj) return FALSE;

	
	pTransObj->procTranslate = transWrapper;

	//Ʒ ۾   transObjectԼ 󿡼 pPostTransBuf null ƴ   ִ.
	pTransObj->nPostTransBufLen=g_nbaseBufSize;
	pTransObj->pPostTransBuf = new char[pTransObj->nPostTransBufLen];


	initObject(pTransObj);

	return TRUE;
}

extern "C" __declspec(dllexport) BOOL __stdcall OnObjectClose(TRANSLATION_OBJECT* pTransObj)
{
	if(NULL == pTransObj) return FALSE;

	closeObject(pTransObj);

	// Delete Pre-translation buffer
	if(pTransObj->pPreTransBuf)
	{
		delete [] (char*)pTransObj->pPreTransBuf;
		pTransObj->pPreTransBuf = NULL;
	}
	pTransObj->nPreTransBufLen = 0;

	// Delete Post-translation buffer
	if(pTransObj->pPostTransBuf)
	{
		delete [] (char*)pTransObj->pPostTransBuf;
		pTransObj->pPostTransBuf = NULL;
	}
	pTransObj->nPostTransBufLen = 0;

	// Reset the translation function pointer
	pTransObj->procTranslate = NULL;

	return TRUE;
}

extern "C" __declspec(dllexport) BOOL __stdcall OnObjectMove(TRANSLATION_OBJECT* pTransObj)
{
	if(NULL == pTransObj)return FALSE;
	if(NULL != pTransObj->pPostTransBuf){
		delete[] pTransObj->pPostTransBuf;
		pTransObj->nPostTransBufLen=0;
	}

	pTransObj->pPostTransBuf = new char[g_nbaseBufSize];
	pTransObj->nPostTransBufLen=g_nbaseBufSize;
	return moveObject(pTransObj);
}

extern "C" __declspec(dllexport) BOOL __stdcall OnObjectOption(TRANSLATION_OBJECT* pTransObj)
{
	BOOL bRetVal = FALSE;

	// Show option dialog and Interact with user.
	if (g_hAralWnd && IsWindow(g_hAralWnd))
	{
		bRetVal = showObjectOption(g_hAralWnd,pTransObj);
	}

	return bRetVal;
}

BOOL __stdcall transWrapper(TRANSLATION_OBJECT* pTransObject)
{
	BOOL bRetVal = FALSE;

	if(NULL == pTransObject) return FALSE;

	TRANSLATION_OBJECT* pPrevObject = pTransObject->pPrevObject;

	if(NULL == pPrevObject) return FALSE;
	if(NULL == pPrevObject->pPreTransBuf || 0 == pPrevObject->nPreTransBufLen) return FALSE;

	return transObject(pTransObject);
}

BOOL transNext(LPSTR szPostTransBuf,size_t nPostTransBufLen,LPCSTR cszPreTransBuf,size_t nPreTransBufLen,TRANSLATION_OBJECT* pTransObject)
{
	BOOL bRetVal = FALSE;

	if(NULL == pTransObject) return FALSE;

	TRANSLATION_OBJECT* pNextObject = pTransObject->pNextObject;

	if(NULL == pNextObject) return FALSE;
	if(NULL == pNextObject->procTranslate) return FALSE;

	//ӽ÷ Ī
	pTransObject->pPreTransBuf = (void*)cszPreTransBuf;
	pTransObject->nPreTransBufLen = nPreTransBufLen;


	BOOL bRes = pNextObject->procTranslate(pTransObject->pNextObject);

	pTransObject->pPreTransBuf = NULL;
	pTransObject->nPreTransBufLen=0;

	if(FALSE == bRes) return FALSE;


	if(NULL == pNextObject->pPostTransBuf || 0 == pNextObject->nPostTransBufLen) return FALSE;

	size_t nTmpBufLen = pNextObject->nPostTransBufLen>nPostTransBufLen?pNextObject->nPostTransBufLen:nPostTransBufLen;
	if(pTransObject->pPostTransBuf)
	{
		if(pTransObject->nPostTransBufLen<nTmpBufLen)
		{
			delete [] (char*)pTransObject->pPostTransBuf;
			pTransObject->pPostTransBuf = NULL;
			pTransObject->nPostTransBufLen = 0;
		}
	}

	if(NULL == pTransObject->pPostTransBuf)
	{
		pTransObject->nPostTransBufLen = nTmpBufLen;
		pTransObject->pPostTransBuf = new char[pTransObject->nPostTransBufLen];
	}

	memcpy_s(szPostTransBuf, nPostTransBufLen, pNextObject->pPostTransBuf,pNextObject->nPostTransBufLen);
	bRetVal = TRUE;

	return bRetVal;
}